# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

module BackendsHelper
  def new_backend_path(backend_class)
    route_helper("new_#{backend_class.name.demodulize.underscore}_backend_path")
  end

  def show_backend_path(backend)
    route_helper(
      "#{backend.class.name.demodulize.underscore}_backend_path",
      backend.id
    )
  end

  def route_helper(name, *args)
    Rails
      .application
      .routes
      .url_helpers
      .send(name, *args)
  end
end
